#include "ds2io.h"

#include "myds2_key.h"

#define KEY_REPEAT_TIME_N	16		//60 times per second


static unsigned int _last_key = 0;
static unsigned int _last_key_timestamp = 0;

unsigned int getNewpress(struct newkey_buf *input) {
	struct key_buf rawin;
	unsigned int new_key, ret_key, timestamp;

	ds2_getrawInput(&rawin);
	timestamp = getSysTime();

	rawin.key &= 0x3FFF;
	new_key = _last_key ^ rawin.key;
	ret_key = 0;
	
	if(new_key)
	{
		if(new_key & rawin.key)
		{
			input->x = rawin.x;
			input->y = rawin.y;
			ret_key |= new_key & rawin.key;
			_last_key_timestamp = timestamp;
		}
		_last_key = rawin.key;
	}
	input->newpress = ret_key;
	return ret_key>0;
}

unsigned int getHold(struct newkey_buf *input) {

	struct key_buf rawin;
	unsigned int new_key, hold_key, ret_key, timestamp;
	int flag;

	ds2_getrawInput(&rawin);
	timestamp = getSysTime();
	flag = ((timestamp - _last_key_timestamp) >= KEY_REPEAT_TIME_N) ? 1 : 0;

	rawin.key &= 0x3FFF;
	hold_key = _last_key & rawin.key;
	
	ret_key = 0;
	if(hold_key) {
		if(flag)
		{
			input->x = rawin.x;
			input->y = rawin.y;
			ret_key = (hold_key << 16) | hold_key;
			_last_key_timestamp = timestamp;
		}
	}
	input->held = ret_key;
	return ret_key>0;
}

