#include <stdlib.h>
#include <ds2_malloc.h>

#include "myds2_timer.h"

timer* ds2timer_create() {
	timer* tempTimer = (timer*)malloc(sizeof(timer));
	tempTimer->start = (unsigned int )getSysTime();
	tempTimer->last  = tempTimer->start;
	return tempTimer;
}

void ds2timer_delete(timer* inTimer) {
	free(inTimer);
}

unsigned int  ds2timer_delta(timer* inTimer) {
	if(inTimer == NULL)
		return 0;
	unsigned int  tempTime = (unsigned int )getSysTime();
	unsigned int  tempOut  = (tempTime - inTimer->last);
	inTimer->last     = tempTime;
	return tempOut;
}

unsigned int  ds2timer_total(timer* inTimer) {
	if(inTimer == NULL)
		return 0;
	return ((unsigned int )getSysTime() - inTimer->start);
}

volatile unsigned long myClockTick=0;

#define ds2timer_time (double) (myClockTick * (1.0 / MYTICKRATE))


void mytimerClock(unsigned int arg) {
  myClockTick++;
}

void ds2timer_sleep(double s) {
  if (s > 0) {
    double curtime = ds2timer_time;
    //while ((curtime + s) > vectrexds2_time);
   while(1) { if ((curtime + s) < ds2timer_time) break; }
  }
}    

void ds2timer_sync(void) {
  static double lasttime = 0;
  double deltatime = 1.0 / (60);
  double curtime;
  lasttime += deltatime;
  ds2timer_sleep(lasttime - ds2timer_time);
  curtime = ds2timer_time;

  if ((lasttime + deltatime) < curtime)
    lasttime = curtime;
}

void ds2timer_init(void) {
  //Interrupt period =100icrosec
  initTimer(1, 1000000/MYTICKRATE, mytimerClock, 0);
  runTimer(1);
}

