#ifndef __myds2_timer_h__
#define __myds2_timer_h__

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdint.h>

#include "ds2_timer.h"

typedef struct {
	unsigned int start;
	unsigned int last;
} timer;

#define timer_resolution (SYSTIME_UNIT*1000)

extern timer*   ds2timer_create();
extern void     ds2timer_delete(timer* inTimer);
extern uint32_t ds2timer_delta(timer* inTimer);
extern uint32_t ds2timer_total(timer* inTimer);

#define MYTICKRATE 100000
extern volatile unsigned long myClockTick;

extern void ds2timer_sleep(double s);
extern void ds2timer_sync(void);
extern void ds2timer_init(void);

#ifdef __cplusplus
}
#endif

#endif
