#include <stdio.h>
#include <string.h>

#include <ds2io.h>
#include <ds2_cpu.h>
#include <ds2_malloc.h>

#include "myds2_wav.h"

int	wave_channle;
int wave_frequence;
int	wave_BytePsample;
int wave_length;

int check_waveheader(void *buffer) {
 WaveHeader *wp = (WaveHeader*)buffer;

  if (wp->main_chunk == RIFF && wp->chunk_type == WAVE &&
    wp->sub_chunk == FMT && wp->data_chunk == DATA) {
    if (wp->format != PCM_CODE) {
      // printf ("can't play not PCM-coded WAVE-files\n");
      return -1;
    }

    if (wp->modus > 2) {
      //printf ("can't play WAVE-files with %d tracks\n", wp->modus);
      return -1;
    }

    wave_channle = wp->modus;
    wave_frequence = wp->sample_fq;
    wave_BytePsample = wp->byte_p_spl;
    wave_length = wp->data_length;
/*		
		printf("wave_channle: %d\n", wave_channle);
		printf("wave_frequence: %d\n", wave_frequence);
		printf("wave_BytePsample: %d\n", wave_BytePsample);
		printf("wave_bitPsamp: %d\n", wp->bit_p_spl);
		printf("wave_length: %d\n", wave_length);
*/
    return 0;
  }

  return -1;
}

int doPlay(void *buffer, int samples_per_trans, int buffer_len) {
  int len;
  int m, n, o;
  void *audiobuf;
  int flag, vol, len_to_dec, curs_act;
  unsigned short *audio_buffer_addr;

  int data_format_interleave_group = 0;
#if 0
  int audio_samples_tab[6] = { 128, 256, 512, 1024, 2048, 4096 };
  int index = 4;
	
	samples_per_trans = audio_samples_tab[index];
	
	ds2_setAudio( wave_frequence, 16, samples_per_trans, 2, data_format_interleave_group );
	
#endif
  len = wave_BytePsample * samples_per_trans;
  curs_act=0;

//  audiobuf = (void*)malloc(len);
//  if(NULL == audiobuf) return -1;
  audiobuf = buffer;

  do {
    audio_buffer_addr = (unsigned short*)ds2_getAudiobuff();
  } while(NULL == audio_buffer_addr);

  vol = 127;
	
  flag = 1;
  while(flag) {
//    memcpy(audiobuf,buffer+curs_act,len);
//    n = fread(audiobuf, 1, len, fp);
    n = len;
//    if(0 == n) break;

    m = (n + len -1)/len;
    m *= len;
    o = 0;
    if (n < m) {
      o = m - n; 
  // memset((char*)((unsigned int)audiobuf + n), 0, m -n);
    }

    //assume 16-bit and stereo audio
    unsigned short *src;
    unsigned short *dst0;
    unsigned short *dst1;

    src = (unsigned short*)audiobuf;
    //the audio buffer's front part are left channel's data, behind ate right
    // channel's data, different as the wave file, it's data not interleaved
    dst0 = audio_buffer_addr;
    dst1 = audio_buffer_addr + samples_per_trans;

    n = 0;
    if( data_format_interleave_group == 1 ) {
      while(n++ < samples_per_trans) {
        *dst0++ = *src++;
        *dst1++ = *src++;
      }
    }
    else {
      while(n++ < samples_per_trans*2) {
        if (o && (n>=m)) *dst0++ = 0;
        else *dst0++ = *src++;
      }
    }

    //ther are 4 audio buffers on the ds2sdk, we should not make it overflow
    while(ds2_checkAudiobuff() >= AUDIO_BUFFER_COUNT) {
      //128 samples (channles * Bytes Per channel) can play 2.9ms @ 44.1KHz
      //mdelay((samples_per_trans/128)*2.9);
      mdelay(1);
    }
    ds2_updateAudio();
    audiobuf+=len;
    curs_act+=len;
    if (curs_act>=buffer_len) break;

    do {
      audio_buffer_addr = (unsigned short*)ds2_getAudiobuff();
    } while(NULL == audio_buffer_addr);
  }
//  free(audiobuf);
  return 0;
}

int play_wave(void *buffer, int buf_len) {
  void *head;
  int flag;

  // begin with wav header
  head=buffer;
  if (check_waveheader(head) == -1) {
    return -1;
  }

  flag = doPlay(buffer+sizeof(WaveHeader), audio_samples_per_trans, buf_len);
  return flag;
}

